#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef struct s_Node
{
	int id;
	struct s_Node *next;
} s_Node;

typedef struct
{
	s_Node *header;
} s_Link;

void link_create(s_Link *link, int n)
{
	s_Node **p = &link->header;
	for (int i = 0; i < n; i++)
	{
		s_Node *node = malloc(sizeof(s_Node));
		node->id = i;
		*p = node;
		p = &(*p)->next;
	}
	*p = link->header;
}

void link_remove(s_Link *link, int num)
{
	s_Node **p = &link->header;
	for (int i = 0; i < num; i++)
	{
		p = &(*p)->next;
	}
	s_Node *del = *p;
	*p = (*p)->next;
	link->header = *p;
	free(del);
}

void link_display(s_Link *link)
{
	s_Node *p = link->header;
	do
	{
		printf("%d ", p->id);
		p = p->next;
	}
	while (p != link->header);
	printf("\n");
}

int main(int argc, char *argv[])
{
	s_Link link;
	link_create(&link, 10);
	printf("\t\t");
	link_display(&link);
	srand((int) time(0));
	for (int i = 0; i < 9; i++)
	{
		int r = rand() % 15;
		printf("rnd = %2d,\t", r + 1);
		link_remove(&link, r + 1);
		link_display(&link);
	}

	return 0;
}
